const util = require("../../utils/util.js");
const app = getApp();
Component({
  options: {
    addGlobalClass: true
  },
  properties: {
    show: {
      type: Boolean,
      observer: function (newVal) {
        this.setData({
          show: newVal,
          checkeduseCoin: false
        });
        if (this.data.show && this.data.cityAid) {
          this.getCalendarInfo();
          console.log(67667)
          this.data.cityList.map((item, index) => {
            if (item.aid == this.data.cityAid) {
              this.setData({
                checkCity: index
              });
            }
          })
        } else {
          this.setData({
            cityAid: this.data.cityList[this.data.checkCity].aid
          });
          this.getCalendarInfo()
        }
      }
    },
    military: { //是否为军事营 1-是 0-否
      type: Number,
      value: 0,
      observer: function (newVal) {
        this.setData({
          military: newVal
        });
      }
    },
    ageLimit: { //活动年龄限制
      type: String,
      value: '',
      observer: function (newVal) {
        this.setData({
          ageLimit: newVal
        });
      }
    },
    s1: {
      type: Number,
      observer: function (newVal) {
        this.data.initialSku.s1 = newVal == '' || newVal == 'undefined' ? -1 : newVal;
        this.setData({
          initialSku: this.data.initialSku
        });
      }
    },
    s2: {
      type: String,
      observer: function (newVal) {
        this.data.initialSku.s2 = newVal == '' || newVal == 'undefined' ? -1 : newVal;
        this.setData({
          initialSku: this.data.initialSku
        });
      }
    },
    shareInfo: {
      type: Object,
      observer: function (newVal) {
        this.setData({
          shareInfo: newVal
        });
      }
    },
    // 选中城市aid
    cityAid: {
      type: String,
      observer: function (val) {
        this.setData({
          cityAid: val
        });
      }
    },
    // 活动tkaid
    tkaid: {
      type: String,
      observer: function (val) {
        this.setData({
          tkaid: val
        });
      }
    },
    atype: {
      type: Number,
      observer: function (newVal) {
        this.setData({
          atype: newVal
        });
      }
    },
    changeSku: { //是否为换场次
      type: Boolean,
      observer: function (newVal) {
        this.setData({
          changeSku: newVal
        });
      }
    },
    recommender: {
      type: String,
      observer: function (newVal) {
        this.setData({
          recommender: newVal
        });
      }
    },
    street: {
      type: String,
      observer: function (newVal) {
        this.setData({
          street: newVal
        });
      }
    },
    familyCommittee: { //0-不需要 1-需要&必填 2-需要&非必填 ,
      type: Number,
      observer: function (newVal) {
        this.setData({
          familyCommittee: newVal
        });
      }
    },
    qptype: {
      type: Number,
      observer: function (newVal) {
        this.setData({
          qptype: newVal
        });
      }
    },
    createGroup: {
      type: Number,
      observer: function (newVal) {
        this.setData({
          createGroup: newVal
        });
      }
    },
    groupid: {
      type: String,
      observer: function (newVal) {
        this.setData({
          groupid: newVal
        });
      }
    },
    orderInfo: {
      type: Object,
      observer: function (newVal) {
        this.setData({
          orderInfo: newVal
        });
      }
    },
    setMeals: {
      type: Object,
      observer: function (newVal) {
        this.data.sku.tree[0].k = newVal[0] || '选择场次';
        this.data.sku.tree[1].k = newVal[1] || '选择套餐';
        this.setData({
          sku: this.data.sku
        });
      }
    },
    presellOpen: {
      type: Number,
      observer: function (newVal) {
        this.setData({
          presellOpen: newVal
        });
      }
    },
    maxUserCoin: {
      type: Number,
      observer: function (newVal) {
        this.setData({
          maxUserCoin: newVal
        });
      }
    },
    cityList: {
      type: Array,
      observer: function (newVal) {
        this.setData({
          cityList: newVal
        });
      }
    },
    goodsInfo: {
      type: Object,
      observer: function (newVal) {
        this.setData({
          goodsInfo: newVal
        });
      }
    },
    userInfo: {
      type: Object,
      observer: function (newVal) {
        if (newVal) {
          this.setData({
            userInfo: newVal,
            phoneNum: newVal.phoneNum
          });
        }
      }
    },
  },
  data: {
    checkeduseCoin: false,
    maxUserCoin: 0, //最大可使用宝贝币数
    saleType: false, //是否为候补
    show: false,
    height: '85%',
    FixHeight: '85%',
    presellOpen: 0,
    cityAid: '',
    tkaid: '',
    atype: 0,
    changeSku: false,
    orderInfo: null,
    qptype: 0,
    recommender: '',
    street: '',
    familyCommittee: 0,
    createGroup: 0,
    groupid: '',
    info: {},
    sku: {
      tree: [{
          k: '选择场次', // skuKeyName：规格类目名称
          v: []
        },
        {
          k: '选择套餐', // skuKeyName：规格类目名称
          v: []
        }
      ],

      price: '0.00', // 默认价格（单位元）
      stock_num: 0, // 商品总库存
      quota: 10, //限购，超过99为不限制购买
      minT: 1,
      maxT: 1,
      presellPrice: 0.00
    },
    initialSku: {
      s1: -1,
      s2: -1,
      selectedNum: 1
    },
    military: 0,
    ageLimit: '',
    //日历信息
    calendarInfo: [],
    sessionInfo: [],
    mealsInfo: [],
    // 日历场次选中项
    checkDate: {},
    checkSession: -1,
    checkMeals: -1,
    // 城市列表
    cityList: [],
    checkCity: 0,
    checkScheduling: 1,
    phoneNum: '',
    // 分享者信息
    shareInfo: {},
    userInfo: '', //用户信息
    defaultPackage: '', //默认套餐 不选择排期时传
  },
  methods: {
    showFund() {
      this.triggerEvent("showFund");
    },
    checkboxChange(e) {
      let initialSku = {
        s1: -1,
        s2: -1,
        selectedNum: 1
      };
      this.setData({
        checkeduseCoin: !this.data.checkeduseCoin,
        initialSku
      });
      this.getCalendarInfo();
    },
    // 获取日历信息
    getCalendarInfo() {
      let that = this;
      let data = {
        aid: that.data.cityAid,
        sid: that.data.initialSku.s1 != -1 ? that.data.initialSku.s1 : ''
      };
      if (this.data.checkeduseCoin) {
        data.useUserCoin = 1;
      }
      util.ajax({
        func: 'v2/article/date/list',
        data,
        load: false
      }, function (res) {
        if (res.code == 0) {
          that.setData({
            calendarInfo: res.data || []
          });
          // 无场次可选 且弹窗打开
          if (!res.data&&that.data.show) {
            // util.showTips('暂无可选场次');
            that.setData({
              checkScheduling: 1
            });
          }
          // 获取默认场次
          if (that.data.checkScheduling == 1) {
            that.getDefault()
          }
        } else {
          util.showTips(data.reason);
        }
      });
    },
    // 获取场次列表
    getSessionInfo(e, type) {
      console.log(e, type, 888888)
      let that = this;
      let data = {
        aid: that.data.cityAid,
        date: e.dateString
      };
      if (this.data.checkeduseCoin) {
        data.useUserCoin = 1;
      }
      util.ajax({
        func: 'v2/article/session/list',
        data,
        load: false
      }, function (res) {
        if (res.code == 0) {
          if (res.data && res.data.length > 0) {
            that.setData({
              sessionInfo: res.data,
              checkSession: that.getDefaultOption(res.data, 0, type == 'click' ? -1 : that.data.initialSku.s1, 1, 'sid') != -1 ? that.getDefaultOption(res.data, 0, type == 'click' ? -1 : that.data.initialSku.s1, 1, 'sid') : that.getDefaultOption(res.data, 0, type == 'click' ? -1 : that.data.initialSku.s1, 2, 'sid')
            });
            if (that.data.checkSession != -1) {
              if (that.data.mealsInfo.length > 0) {
                that.setData({
                  mealsInfo: []
                });
              }
              that.getMealsInfo(type);
            }
          }
        } else {
          util.showTips(data.reason);
        }
      });
    },
    // 获取套餐/排列表
    getMealsInfo(type) {
      let that = this;
      if (that.data.mealsInfo.length > 0) {
        that.setData({
          mealsInfo: []
        });
      }
      let sid = that.data.sessionInfo[that.data.checkSession].sid;
      let data = {
        sid: sid
      };
      if (this.data.checkeduseCoin) {
        data.useUserCoin = 1;
      }
      util.ajax({
        func: 'v2/article/meal/list',
        data,
        load: false
      }, function (res) {
        if (res.code == 0) {
          if (res.data && res.data.length > 0) {
            that.setData({
              mealsInfo: res.data,
              checkMeals: that.getDefaultOption(res.data, 0, type == 'click' ? -1 : that.data.initialSku.s2, 1, 'pid') != -1 ? that.getDefaultOption(res.data, 0, type == 'click' ? -1 : that.data.initialSku.s2, 1, 'pid') : that.getDefaultOption(res.data, 0, type == 'click' ? -1 : that.data.initialSku.s2, 2, 'pid')
            });

            if (that.data.checkMeals != -1) {
              let num = 0;
              if (that.data.presellOpen == 0) {
                num = that.data.mealsInfo[that.data.checkMeals].actnum > 0 ? that.data.mealsInfo[that.data.checkMeals].actnum : that.data.mealsInfo[that.data.checkMeals].actnum <= 0 && that.data.mealsInfo[that.data.checkMeals].waitActNum > 0 ? that.data.mealsInfo[that.data.checkMeals].waitActNum : 0;
                that.data.saleType = that.data.mealsInfo[that.data.checkMeals].actnum <= 0 && that.data.mealsInfo[that.data.checkMeals].waitActNum > 0 ? true : false;
                that.setData({
                  saleType: that.data.saleType
                });
              } else {
                num = that.data.mealsInfo[that.data.checkMeals].actnum;
              }
              that.setData({
                'initialSku.selectedNum': that.data.mealsInfo[that.data.checkMeals].minT,
                'sku.stock_num': num,
                'sku.maxT': that.data.mealsInfo[that.data.checkMeals].maxT,
                'sku.minT': that.data.mealsInfo[that.data.checkMeals].minT
              });
            }
          }
        } else {
          util.showTips(data.reason);
        }
      });
    },
    // 递归判断场次默认项
    getDefaultOption(arr, index, id, opt, type) {
      if (arr.length > 0 && index < arr.length) {
        if (id != -1) {
          if (arr[index][type] == id && (
              arr[index].status == 0 && arr[index].actnum > 0 ||
              arr[index].status == 1 && arr[index].actnum <= 0 && arr[index].waitActNum > 0 && this.data.presellOpen == 0)) {
            return index;
          } else {
            return this.getDefaultOption(arr, index + 1, id, opt, type);
          }
        } else {
          if (opt == 1) {
            let obj = arr[index];
            if (obj.actnum > 0 && obj.status == 0) {
              return index;
            } else {
              return this.getDefaultOption(arr, index + 1, id, opt, type);
            }
          } else if (opt == 2) {
            let obj = arr[index];
            if (obj.actnum <= 0 && obj.waitActNum > 0 && obj.status == 1 && this.data.presellOpen == 0) {
              return index;
            } else {
              return this.getDefaultOption(arr, index + 1, id, opt, type);
            }
          }
        }
      }
      return -1;
    },
    close(e) {
      this.triggerEvent("close", e.detail);
    },
    // 选择城市
    selectCity(e) {
      console.log('城市', e)
      this.setData({
        checkCity: e.currentTarget.dataset.i,
        aid: e.currentTarget.dataset.cityAid
      })
      this.getCalendarInfo()
    },
    // 选择排期
    selectScheduling(e) {
      this.setData({
        checkScheduling: e.currentTarget.dataset.i
      })
      if (this.data.checkScheduling == 1) {
        this.getDefault()
      }
    },
    getDefault() {
      console.log(677755)
      let that = this;
      let data = {
        aid: that.data.cityAid,
        date: '3000-01-01'
      }
      util.ajax({
        func: 'v2/article/session/list',
        data,
        load: false
      }, function (res) {
        if (res.code == 0) {
          let sid = res.data[0].sid
          util.ajax({
            func: 'v2/article/meal/list',
            data: {
              sid: sid
            },
            load: false
          }, function (res) {
            if (res.code == 0) {
              let defaultPackage = []
              // 只取活动套餐名是活动费的
              if (res.data && res.data.length > 0) {
                res.data.forEach(element => {
                  if (element.policyName == '活动费') {
                    defaultPackage.push(element)
                  }
                });
              }
              // 默认场次默认套餐
              that.setData({
                defaultPackage: defaultPackage,
                mealsInfo: defaultPackage,
                checkMeals: 0
              })
            } else {
              util.showTips(data.reason);
            }
          });
        } else {
          util.showTips(data.reason);
        }
      });
    },
    // 手机号
    bindKeyInput(e) {
      this.setData({
        phoneNum: e.detail.value
      });
    },
    // 选择日历
    changeDate(e) {
      let obj = e.detail,
        type = '';
      if (obj.bol) {
        this.setData({
          'initialSku.s1': -1
        });
        type = 'click';
      }
      this.setData({
        checkDate: obj
      });
      if (this.data.sessionInfo.length > 0) {
        this.setData({
          sessionInfo: []
        });
      }
      if (!util.isEmpty(obj) && obj.day != 0) {
        this.getSessionInfo(obj, type);
      }
    },
    // 选择场次
    selectSession(e) {
      let val = e.currentTarget.dataset.item,
        i = e.currentTarget.dataset.i;
      if (val.status == 2 || val.status == 1 && this.data.presellOpen == 1 || val.actnum <= 0 && val.waitActNum <= 0 && this.data.presellOpen == 0 || this.data.checkSession == i) {
        return false;
      }
      this.setData({
        checkSession: i
      });
      this.getMealsInfo('click');
    },
    // 选择套餐
    selectMeals(e) {
      let val = e.currentTarget.dataset.item,
        i = e.currentTarget.dataset.i,
        num = 0,
        that = this;
      if (this.data.military == 1 && (val.status == 2 || val.status == 1 && this.data.presellOpen == 1 || val.actnum <= 0 && val.waitActNum <= 0 && this.data.presellOpen == 0 || this.data.checkMeals == i)) {
        return false;
      }
      this.setData({
        checkMeals: i
      });
      if (that.data.presellOpen == 0) {
        num = that.data.mealsInfo[that.data.checkMeals].actnum > 0 ? that.data.mealsInfo[that.data.checkMeals].actnum : that.data.mealsInfo[that.data.checkMeals].actnum <= 0 && that.data.mealsInfo[that.data.checkMeals].waitActNum > 0 ? that.data.mealsInfo[that.data.checkMeals].waitActNum : 0;
        that.data.saleType = that.data.mealsInfo[that.data.checkMeals].actnum <= 0 && that.data.mealsInfo[that.data.checkMeals].waitActNum > 0 ? true : false;
        that.setData({
          saleType: that.data.saleType
        });
      } else {
        num = that.data.mealsInfo[that.data.checkMeals].actnum;
      }
      this.setData({
        'initialSku.selectedNum': val.minT,
        'sku.stock_num': num,
        'sku.maxT': that.data.mealsInfo[that.data.checkMeals].maxT,
        'sku.minT': that.data.mealsInfo[that.data.checkMeals].minT
      });
    },
    quantity(e) {
      let type = e.currentTarget.dataset.type,
        val = e.detail.value;
      switch (type) {
        case 'minus':
          this.data.initialSku.selectedNum--;
          break;
        case 'plus':
          this.data.initialSku.selectedNum++;
          break;
        case 'modfiy':
          this.data.initialSku.selectedNum = val;
          break;
      }
      // 不选择排期 和默认项比较
      if (this.data.checkScheduling == 1) {
        if (parseInt(this.data.initialSku.selectedNum) > this.data.defaultPackage[0].stock_num) {
          util.showTips("库存不足");
          this.data.initialSku.selectedNum = this.data.defaultPackage[0].actnum;
        }
        if ((type == 'minus' || type == 'modfiy') && (parseInt(this.data.initialSku.selectedNum) < this.data.defaultPackage[0].minT || util.isEmpty(this.data.initialSku.selectedNum))) {
          util.showTips("至少选择" + this.data.defaultPackage[0].minT + "件");
          this.data.initialSku.selectedNum = this.data.defaultPackage[0].minT;
        }
        if ((type == 'plus' || type == 'modfiy') && parseInt(this.data.initialSku.selectedNum) > this.data.defaultPackage[0].maxT) {
          util.showTips("最大只能购买" + this.data.defaultPackage[0].maxT + "件");
          this.data.initialSku.selectedNum = this.data.defaultPackage[0].maxT;
        }
      } else {
        if (parseInt(this.data.initialSku.selectedNum) > this.data.sku.stock_num) {
          util.showTips("库存不足");
          this.data.initialSku.selectedNum = this.data.sku.stock_num;
        }
        if ((type == 'minus' || type == 'modfiy') && (parseInt(this.data.initialSku.selectedNum) < this.data.sku.minT || util.isEmpty(this.data.initialSku.selectedNum))) {
          util.showTips("至少选择" + this.data.sku.minT + "件");
          this.data.initialSku.selectedNum = this.data.sku.minT;
        }
        if ((type == 'plus' || type == 'modfiy') && parseInt(this.data.initialSku.selectedNum) > this.data.sku.maxT) {
          util.showTips("最大只能购买" + this.data.sku.maxT + "件");
          this.data.initialSku.selectedNum = this.data.sku.maxT;
        }
      }
      this.setData({
        initialSku: this.data.initialSku
      });
    },
    // 触发登录
    getPhoneNumber(e) {
      tt.login({
        success: (res) => {
          this.setData({
            code: res.code
          });
        },
        fail: (err) => {
          console.log(err, 8)
        }
      });
      let that = this;
      let data = {};
      if (e.detail.errMsg == "getPhoneNumber:ok") {
        console.log(e, '手机号')
        tt.login({
          success: (res) => {
            data.code = res.code
            data.iv = e.detail.iv
            data.encryptedData = e.detail.encryptedData
            util.ajax({
              func: "v2/login/tiktok/applet_login",
              data: data,
              method: "POST",
            }, function (data) {
              if (data.code == 0) {
                data.data.role = util.userRole(Math.round(data.data.score));
                tt.setStorageSync("WXuserInfo", data.data);
                app.globalData.userInfo = data.data;
                that.setData({
                  userInfo: app.globalData.userInfo,
                  phoneNum: app.globalData.userInfo.phoneNum
                });
                that.sumbit()
              } else
                util.showTips(data.reason);
            });
          },
          fail: (err) => {
            console.log(err)
          }
        });
      } else {
        // util.showTips(e.detail.errMsg);
      }
    },
    sumbit(e) {
      let type = (this.data.saleType && this.data.presellOpen == 0) ? 1 : 0,
        initialSku = this.data.initialSku;
      if (this.data.checkCity == -1 || this.data.cityList[this.data.checkCity].stockNum == 0) {
        util.showTips('请选择城市');
        return false;
      }
      if (this.data.checkScheduling != 1 && this.data.checkSession == -1) {
        util.showTips('请选择场次');
        return false;
      }
      if (this.data.checkScheduling != 1 && this.data.checkMeals == -1) {
        util.showTips('请选择' + this.data.military == 1 ? "排" : "套餐");
        return false;
      }
      // 手机号
      if (!this.data.phoneNum) {
        util.showTips("请填写手机号");
        return false;
      }
      tt.reportAnalytics('active_enroll', {
        aid: this.data.cityAid,
        title: this.data.title
      });
      this.toBuy(type);
    },

    toBuy(type) {
      // 判断当前API是否正在调用
      if (this.data.APILoading) {
        return
      }
      this.setData({
        APILoading: true
      })
      // console.log(this.data, 89898)
      let that = this,
        sessionContent = {} //选择的套餐
      // 暂不选择
      if (that.data.checkScheduling == 1) {
        sessionContent = that.data.defaultPackage[0]
      } else {
        // 选择具体的
        sessionContent = that.data.mealsInfo[that.data.checkMeals]
      }
      let data = {},
        // totalPrice = that.data.initialSku.selectedNum * sessionContent.price * 100, //总价 以分为单位
        totalPrice = that.data.initialSku.selectedNum * that.data.goodsInfo.actualAmount * 100, //总价 以分为单位
        meals = sessionContent.pid + '|' + that.data.initialSku.selectedNum //套餐信息
      data.rid = app.globalData.userInfo ? app.globalData.userInfo.rid : ''
      data.aid = that.data.cityAid
      data.tkaid = that.data.tkaid
      data.phone = that.data.phoneNum
      data.meals = meals || ''
      console.log(data.aid, 56)
      console.log('商品数', that.data.initialSku.selectedNum, '价格', that.data.goodsInfo.actualAmount, '总价', totalPrice, '套餐pid', meals)
      // 预下单
      tt.createOrder({
        skuList: [{
          skuId: that.data.goodsInfo.skuId, // sku 商品Id 必传
          skuType: 2, // sku 商品类型 必传
          quantity: that.data.initialSku.selectedNum, // 数量 必传
          // price: sessionContent.price * 100, // 价格 非商品库 sku 商品必传
          price: that.data.goodsInfo.actualAmount * 100, // 价格 非商品库 sku 商品必传
          goodsInfo: {
            goodsName: that.data.goodsInfo.title, // 商品名称 必填
            goodsPhoto: that.data.goodsInfo.logo, // 商品图片链接 必填
            goodsId: that.data.goodsInfo.skuId, // 商品ID 必填
            goodsType: 1, // 商品类型 必填
            goodsLabels: [], // 商品标签 非必填
            dateRule: "", // 使用规则 非必填
          },
        }],
        payment: {
          totalAmount: totalPrice, // 订单总价 必填
        },
        contactInfo: {
          phoneNumber: "", // 手机号 非必传
          contactName: "", // 姓名 非必传
        },
        note: "", // 备注 非必传
        storeInfo: {
          storeName: "", // 商店名称 非必传
          storeIcon: "", // 商店头像 非必填
        },
        goodsPage: {
          path: "pages/product/activity/index",
          params: {
            aid: that.data.cityAid
          },
        },
        callbackData: data, // 透传数据，开发者自定义字段 非必传
        tradeOption: {
          life_trade_flag: 0 // 0：非融合链路（默认值）  1：走融合链路（标准融合/完全融合）
        }, // 透传数据，开发者自定义字段 非必传
        success: (res) => {
          // 重置调用状态
          that.setData({
            APILoading: false
          })
          const {
            orderId,
            outOrderNo
          } = res;
          tt.navigateTo({
            url: '/pages/order/success/index?orderid=' + outOrderNo
          });
          console.log("success res", res);
          console.log("orderId888888", orderId, "outOrderNo", outOrderNo, );
        },
        fail: (res) => {
          // 重置调用状态
          that.setData({
            APILoading: false
          })
          const {
            orderId,
            outOrderNo,
            errNo,
            errMsg,
            errLogId
          } = res;
          if (errNo != 4) {
            util.showTips(errMsg);
            if (errLogId) {
              console.log(res, "预下单失败", errNo, errMsg, errLogId);
            }
            if (orderId || outOrderNo) {
              console.log("支付失败", errNo, errMsg, orderId, outOrderNo);
            }
            console.log(errNo, errMsg, res);
          }
        },
      });
    },
    // 关注服务号
    confirm() {
      this.triggerEvent("showCode");
    },
    // 确认换场次
    confirmChange() {
      // console.log(this.data.orderInfo);
      let dateTimeNow = new Date().getTime(),
        that = this;
      if (this.data.sessionInfo[this.data.checkSession].stopBuy < dateTimeNow) {
        util.showTips('所选择的场次已经截止报名，请选择其他场次~');
        return false;
      }
      if (this.data.military != 1 && this.data.initialSku.s1 == this.data.sessionInfo[this.data.checkSession].sid) {
        util.showTips('本活动为非军事营活动，不可更换同场次下的套餐！');
        return false;
      }
      if (this.data.military != 1 && this.data.sessionInfo[this.data.checkSession].actnum <= 0 && this.data.sessionInfo[this.data.checkSession].waitActNum > 0) {
        util.showTips('不可更换为候补状态的场次！');
        return false;
      }
      if (this.data.military == 1 && that.data.mealsInfo[that.data.checkMeals].actnum <= 0 && that.data.mealsInfo[that.data.checkMeals].waitActNum > 0) {
        util.showTips('不可更换为候补状态的排！');
        return false;
      }
      util.requestMsg(['mohcEpMGh7PYk3apc9qLf7BLQ-_eZGi8WqcBElUsjX8', 'mohcEpMGh7PYk3apc9qLf7BLQ-_eZGi8WqcBElUsjX8'], true).then((e) => {
        let zid = that.data.mealsInfo[that.data.checkMeals].zid;
        that.triggerEvent('confirmChange', zid);
      });
    }
  }
});