const util = require('../../utils/util.js');
const app = getApp();

Component({
  properties: {
    show: {
      type: Boolean,
      observer: function (newVal, oldVal) {
        this.setData({
          show: newVal
        });
      }
    },
    options: {
      type: Object,
      observer: function (newVal, oldVal) {
        if (!util.isObjEmpty(newVal)) {
          this.setData({
            aid: newVal.aid,
            orderid: newVal.orderid,
            sname: newVal.sname,
            title: newVal.title
          });
        }
      }
    }
  },
  data: {
    imgUrl: [],
    uploadImg: [],
    star: 0,
    aid: '',
    title: '',
    sname: '',
    orderid: '',
    type: '',
    act: '',
    content: '', //评价
    cid: '',
    one: [{
      txt: '带队技能欠佳',
      cet: false
    }, {
      txt: '与宣传有差距',
      cet: false
    }, {
      txt: '活动不合理',
      cet: false
    }, {
      txt: '孩子体验一般',
      cet: false
    }, {
      txt: '吃住有待升级',
      cet: false
    }, {
      txt: '性价比一般',
      cet: false
    }],
    two: [{
      txt: '正能量的小黄人',
      cet: false
    }, {
      txt: '领队专业细心',
      cet: false
    }, {
      txt: '教育意义明显',
      cet: false
    }, {
      txt: '活动安排有序',
      cet: false
    }, {
      txt: '安全措施到位',
      cet: false
    }, {
      txt: '性价比超值',
      cet: false
    }],
    chooseIndex: [],
    option: [],
    show: false, //是否显示
    detailStatus: false, //详情是否出现
    recommendArr: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10], //推荐值数组
    recomLevel: 0, //推荐值
    inputFocus: false
  },
  methods: {
    chooseImg() {
      let that = this,
        uploadImg = that.data.uploadImg,
        count = 8 - uploadImg.length,
        arr = [];
      that.triggerEvent('selectImage', {
        isGet: false
      });
      tt.chooseMedia({
        count: count,
        mediaType: ['image'],
        sizeType: ['compressed', 'compressed'], //可以指定是原图还是压缩图
        sourceType: ['album', 'camera'], //从相册选择
        success: (res) => {
          let imgUrl = res.tempFiles;
          if (imgUrl.length + that.data.uploadImg.length > 8) {
            util.showTips("最多只能上传8张照片");
            return false;
          }
          res.tempFiles.forEach((item) => {
            let avatarUrl = item.tempFilePath;
            tt.showLoading({
              title: '上传中…'
            });
            util.uploadFile("oss/policy", avatarUrl, {
              type: 'baoBeiEvaluate'
            }, true).then((res) => {
              if (res.code == 0) {
                arr.push(res.url);
                uploadImg.push(res.url);
                if (arr.length == imgUrl.length) {
                  that.setData({
                    uploadImg
                  });
                  tt.hideLoading();
                  that.triggerEvent('selectImage', {
                    isGet: true
                  });
                }
              }
            });
          });
        }
      });
    },
    delImg(e) {
      let index = e.currentTarget.dataset.index,
        uploadImg = this.data.uploadImg;
      uploadImg.splice(index, 1);
      this.setData({
        uploadImg
      });
    },
    submit() {
      var that = this,
        data = {},
        uploadImg = this.data.uploadImg,
        act = this.data.act,
        userInfo = app.globalData.userInfo,
        star = this.data.star,
        content = this.data.content,
        option = this.data.two;
      if (star == 1 || star == 2) {
        option = this.data.one;
      }
      for (let i in option) {
        if (option[i].cet) {
          content = content + '#' + option[i].txt + '#';
        }
      }
      data['aid'] = this.data.aid;
      data['orderid'] = this.data.orderid; //订单id
      data['arating'] = star; //活动评分
      data['leaderrating'] = '5'; //领队评分
      data['content'] = content;
      data['cid'] = this.data.cid;
      data['image'] = uploadImg ? uploadImg.join(',') : '';
      data['rid'] = userInfo ? userInfo['rid'] : "";
      data['recomLevel'] = this.data.recomLevel;
      if (this.data.recomLevel == 0) {
        util.showTips("请点击数字对本次活动体验进行打分");
        return false;
      }
      if (util.isEmpty(data.content)) {
        util.showTips("请填写评分原因");
        return false;
      }
      util.ajax({
        func: "v2/comments/order/addcomment",
        data: data,
        method: "POST",
        load: true,
        title: '提交中'
      }, function (res) {
        tt.hideLoading();
        if (res.code == 0) {
          tt.redirectTo({
            url: '/pages/order/scratch/scratch?orderid=' + that.data.orderid + '&coin=' + res.data || 0
          });
        } else {
          util.showTips(res.reason);
        }
      });
    },
    chooseOpt: function (e) {
      var star = this.data.star,
        chooseIndex = this.data.chooseIndex,
        index = e.currentTarget.dataset.index,
        option = this.data.two;
      if (star == 1 || star == 2) {
        option = this.data.one;
      }
      if (option[index].cet) {
        option[index].cet = false;
      } else {
        option[index].cet = true;
      }
      if (star == 1 || star == 2) {
        this.setData({
          one: option
        });
      } else {
        this.setData({
          two: option
        });
      }
    },
    bindblur: function (e) {
      this.setData({
        content: e.detail.value,
        inputFocus: false
      });
    },
    bindinput(e) {
      this.setData({
        content: e.detail.value
      });
    },
    bindstar: function (e) {
      this.setData({
        star: e.target.dataset.index,
        detailStatus: true
      });
    },
    bindfocus(e) {
      this.setData({
        inputFocus: true
      });
    },
    recommend(e) {
      this.setData({
        recomLevel: e.target.dataset.number
      });
    },
    close() {
      this.saveDataToLocal();
    },
    // 保存草稿至本地
    saveDataToLocal() {
      console.log(676756, this.data.content, this.data.uploadImg);
      let that = this,
        commentData = {},
        option = this.data.two;
      if (!util.isEmpty(this.data.content) || this.data.uploadImg.length > 0) {
        commentData.orderid = this.data.orderid;
        commentData.saveDate = util.getNowFormatDate('yyyy-MM-dd hh:mm:ss');
        commentData.arating = this.data.star;
        commentData.crating = this.data.cusStar;
        commentData.recomLevel = this.data.recomLevel;
        commentData.images = this.data.uploadImg || '';
        let content = this.data.content.replace(/\n/g, '<br/>');
        if (this.data.star == 1 || this.data.star == 2) {
          option = this.data.one;
        }
        for (let i in option) {
          if (option[i].cet) {
            content = content + '#' + option[i].txt + '#';
          }
        }
        commentData.content = content;
        tt.setStorageSync("orderComment", commentData);
        this.triggerEvent('myevent', {}, {});
      } else {
        this.triggerEvent('myevent', {}, {});
      }
      console.log(676756999);

    }
  }
});