Component({
  /**
   * 组件的属性列表
   */
  properties: {
    previewImgList: {
      type: Array,
      value: []
    },
    previewImg: {
      type: null,
      value: ''
    },
    originalArr: {
      type: Array,
      value: []
    }
  },
  /**
   * 组件的初始数据
   */
  data: {
    preview_box_top: 0,
    left: '0px;',
    touchS: [0, 0],
    touchE: [0, 0],
    index: 0,
    imgindex: 0,
    previewHideStatus: false,
    scale: 1,
    scaleObj: {
      scale: 1,
      x: 0,
      y: 0,
      yes: true
    },
    touchStartTime: 0, // 触摸开始时间
    touchEndTime: 0, // 触摸结束时间
    lastTapTime: 0, // 最后一次单击事件点击发生时间
    lastTapTimeoutFunc: null, // 单击事件点击后要触发的函数
    progressShow: false, //下载进度
    downloadNum: 0, //图片下载数
    completeNum: 0, //下载完成数
    downloadCompleted: false //下载全部完成  进度动画后
  },
  /**
   * 组件的方法列表
   */
  methods: {
    // 错误图展示
    imgListBinderror(e) {
      var photos = this.data.previewImgList,
        index = e.currentTarget.dataset.index;
      // console.log(e.currentTarget.dataset.index,photos)
      photos[index].url = '/images/noimg.png';
      this.setData({
        previewImgList: photos
      });
    },
    // 查看原图
    showOriginal(e) {
      tt.showLoading();
      let index = this.data.imgindex - 1;
      this.data.previewImgList[index].url = this.data.originalArr[index];
      this.data.previewImgList[index].originalShow = true;
      this.setData({
        previewImgList: this.data.previewImgList
      });
    },
    // 下载原图
    downloadOriginal(e) {
      this.setData({
        progressShow: true,
        downloadNum: 1,
        completeNum: 0,
        downloadCompleted: false
      });
      let index = this.data.imgindex - 1;
      let url = this.data.originalArr[index];
      let that = this;
      tt.downloadFile({
        url: url,
        success: function (res) {
          var temp = res.tempFilePath;
          // 未取消保存
          if (that.data.progressShow) {
            // 授权拒绝后再获取授权
            tt.getSetting({
              success: (setRes) => {
                // 未授权
                if (setRes.authSetting["scope.writePhotosAlbum"] === false) {
                  tt.showModal({
                    title: '提示',
                    content: '需要获取相册权限',
                    success: function (setShowRes) {
                      if (setShowRes.confirm) {
                        //  打开授权页面,让用户手动打开权限
                        tt.openSetting({
                          success: function (data) {
                            tt.saveImageToPhotosAlbum({
                              filePath: temp,
                              success(saveRes) {
                                that.setData({
                                  completeNum: that.data.completeNum + 1
                                });
                              },
                              fail: function (err) {
                                tt.showToast({
                                  title: '保存失败，请重试',
                                  duration: 3000,
                                  icon: 'none'
                                });
                              }
                            });
                          }
                        });
                      }
                    }
                  });
                } else {
                  tt.saveImageToPhotosAlbum({
                    filePath: temp,
                    success(saveRes) {
                      that.setData({
                        completeNum: that.data.completeNum + 1
                      });
                    },
                    fail: function (err) {
                      tt.showToast({
                        title: '保存失败，请重试',
                        duration: 3000,
                        icon: 'none'
                      });
                    }
                  });
                }
              }
            });
          }
        },
        fail: function (err) {
          tt.showToast({
            title: '保存失败，请重试',
            duration: 3000,
            icon: 'none'
          });
        }
      });
    },
    // 关闭下载弹窗和多选，清空选择数据和状态
    closePro() {
      this.setData({
        progressShow: false
      });
    },
    // 下载完成
    downloadComplete() {
      // 最后一次下载
      if (this.data.completeNum == this.data.downloadNum) {
        this.setData({
          downloadCompleted: true
        });
      }
    },
    bindload(e) {
      tt.hideLoading();
    },
    jingzhi(e) {
      let curTime = e.timeStamp;
      let lastTime = this.data.lastTapDiffTime;
      this.data.lastTapDiffTime = curTime;
      //两次点击间隔小于300ms, 认为是双击
      let diff = curTime - lastTime;
      let that = this;
      if (diff < 300) {
        // console.log("double tap")
        clearTimeout(this.data.lastTapTimeoutFunc); // 成功触发双击事件时，取消单击事件的执行
        if (that.data.scale == 1) {
          that.setData({
            scale: 3
          });
        } else {
          that.setData({
            scale: 1
          });
        }
      } else {
        // 传给页面
        let obj = {
          type: "show",
          currentPage: Math.ceil(this.data.imgindex / 12), //12是图片列表页每页张数
          imgindex: this.data.imgindex
        };
        this.triggerEvent('listener', obj);
        this.data.lastTapTimeoutFunc = setTimeout(function () {
          // console.log("single tap")
          if (that.data.scaleObj.yes) {
            that.setData({
              preview_box_top: '100%'
            });
          }
        }, 300);
      }
    },
    configqxClick(e) {
      this.setData({
        scopeWritePhotosAlbum: e.detail
      });
    },
    touchStart: function (e) {
      this.data.touchStartTime = e.timeStamp; //时间点
      let sx = e.touches[0].pageX;
      let sy = e.touches[0].pageY;
      this.data.touchS = [sx, sy];
    },
    touchMove: function (e) {
      let start = this.data.touchS;
      let sx = e.touches[0].pageX;
      let sy = e.touches[0].pageY;
      this.data.touchE = [sx, sy];
    },
    touchEnd: function (e) {
      this.data.touchEndTime = e.timeStamp; //时间点
      let start = this.data.touchS;
      let end = this.data.touchE;
      let scaleObj = this.data.scaleObj;
      //如果((start[0] < end[0] - 50) && (scaleObj.scale==1&&scaleObj.x==0&&scaleObj.y==0)) //左滑动
      //如果((start[0] > end[0] + 50) && (scaleObj.scale==1&&scaleObj.x==0&&scaleObj.y==0)) //右滑动
      if (scaleObj.yes) {
        if (end[0] == 0) {

          // console.log('点击')
        } else if (start[0] < end[0] - 50 && scaleObj.scale == 1 && scaleObj.x == 0 && scaleObj.y == 0) {if (this.data.index !== 0) {
            this.data.index -= 1;
            this.data.imgindex -= 1;
            this.setData({
              index: this.data.index,
              left: '-' + this.data.index + '00%;transition: all .5s;',
              imgindex: this.data.imgindex
            });

            // 传给页面
            let obj = {
              type: "slide",
              currentPage: Math.ceil(this.data.imgindex / 12), //12是图片列表页每页张数
              imgindex: this.data.imgindex
            };
            this.triggerEvent('listener', obj);
          }
        } else if (start[0] > end[0] + 50 && scaleObj.scale == 1 && scaleObj.x == 0 && scaleObj.y == 0) {
          if (this.data.index !== this.data.previewImgList.length - 1) {
            this.data.index += 1;
            this.data.imgindex += 1;
            this.setData({
              index: this.data.index,
              left: '-' + this.data.index + '00%;transition: all .5s;',
              imgindex: this.data.imgindex
            });
            // 传给页面
            let obj = {
              type: "slide",
              currentPage: Math.ceil(this.data.imgindex / 12), //12是图片列表页每页张数
              imgindex: this.data.imgindex
            };
            this.triggerEvent('listener', obj);
          } else {
            tt.showToast({
              title: '没有下一张照片啦~',
              icon: 'none',
              mask: true,
              duration: 2000
            });
          }
        } else {
          this.setData({
            preview_box_top: '100%'
          });
        }
        this.data.touchE = [0, 0];
      }

      setTimeout(() => {
        if (this.data.scaleObj.x == 0 && this.data.scaleObj.y == 0 && this.data.scaleObj.scale == 1) {
          // console.log('yes is true');
          this.data.scaleObj.yes = true;
        }
      }, 500);
    },
    showPreview() {
      this.setData({
        previewHideStatus: true,
        preview_box_top: 0
      });
    },
    hidePreview() {
      this.setData({
        previewHideStatus: false,
        preview_box_top: 0
      });
    },
    onScale(e) {
      this.data.scaleObj = {
        scale: e.detail.scale,
        x: e.detail.x,
        y: e.detail.y,
        yes: false
      };
    },
    stopPageScroll() {
      return;
    }
  },
  observers: {
    'previewImgList': function (arr) {

      // console.log(arr, 999, this.data.originalArr)
    }, 'previewImg': function (img) {
      this.data.previewImgList.map((item, index) => {
        if (item.url == img) {
          let imgindex = index;
          imgindex += 1;
          this.setData({
            index: index,
            imgindex: imgindex,
            left: '-' + index + '00%;'
          });
        }
      });
    }
  }
});