// 虚拟列表+瀑布流
Component({
  properties: {
    // 当前虚拟子模块唯一ID
    virtualId: {
      type: String,
      value: '',
      observer() {
        this.getCurrentItemHeight();
      }
    },
    //  显示当前页 用于预览退出定位
    currentPage: {
      type: String,
      value: ''
    },
    // 父级滚动容器ID，如果需要以指定容器处理
    wrapId: {
      type: String,
      value: ''
    },
    // 离可见区域的距离，单位px
    observeDistance: {
      type: Number,
      value: 1500
    }
  },
  data: {
    height: 0,
    isShow: true,
    pageNum: 0
  },
  methods: {
    getCurrentItemHeight() {
      const query = this.createSelectorQuery();
      const {
        virtualId
      } = this.data;
      query.select(`#${virtualId}`).boundingClientRect();
      query.exec((res) => {
        this.setData({
          height: res[0].height
        }, this.observePage());
      });
    },
    observePage() {
      var index = this.data.virtualId.lastIndexOf("\_"); //获取-后边的字符串
      this.data.pageNum = this.data.virtualId.substring(index + 1, this.data.virtualId.length);
      this.setData({
        pageNum: this.data.pageNum
      });
      const {
        virtualId,
        observeDistance,
        wrapId
      } = this.data;
      let IntersectionObserver = tt.createIntersectionObserver(this);
      (wrapId ? IntersectionObserver.relativeTo(`#${wrapId}`) : IntersectionObserver.relativeToViewport({
        top: observeDistance,
        bottom: observeDistance
      })).
      observe(`#${virtualId}`, ({
        intersectionRatio
      }) => {
        this.setData({
          isShow: intersectionRatio > 0
        });
      });
    }
  }
});