const util = require("../../../utils/util.js");
var app = getApp();
const config = require('../../../utils/config');
Page({
  data: {
    imgPath: util.config.imgPath,
    selectMore: false,
    checkedGroup: [], //批量保存选择图片url
    showShare: false, //分享弹窗
    picGroup: [], //当前活动下数据
    activeDate: 0, //选中日期
    picArr: [], //原图列表
    liveId: "",
    imgArr: [],
    num: 24,
    current: '', //预览当前index
    ceilingShow: false, //吸顶
    // 页面展示数据参数
    listQuery: {
      pageIndex: 0,
      pageSize: 12
    },
    currentPage: 0, //预览当前页
    // 列表请求参数
    listData: [], // 列表数据
    column: 2, // 列数
    columnsHeights: [0, 0], // 每列高度
    progressShow: false, //下载进度
    downloadNum: 0, //图片下载数
    completeNum: 0, //下载完成数
    downloadCompleted: false, //下载全部完成  进度动画后
    bottomId: '', //定位id
    // 拍摄时间同步定位
    topTimeId: '',
    timeId: '',
    actCity: '',
    actTime: ''
  },
  onLoad(options) {
    this.setData({
      viewHeight: tt.getSystemInfoSync().windowHeight
    });
    // scene扫码
    if (options.liveId || options.scene) {
      this.setData({
        liveId: options.liveId ? options.liveId : options.scene
      });
      this.getInfor();
      this.getPicture();
      return;
    }
  },
  onShow(options) {
    let option = app.globalData.info;
    if (option && option.liveId != "") {
      // this.nps()
      this.setData({
        liveId: option.liveId
      });
      this.getInfor();
      this.getPicture();
    }
  },
  // 当前页的数据处理
  setImgArr() {
    let {
      listQuery: {
        pageIndex,
        pageSize
      }
    } = this.data;
    let start = pageIndex * pageSize;
    let end = start + (pageSize - 1);
    const list = this.data.picGroup.cameraPhotos[this.data.activeDate].photoList.slice(start, end);
    let obj = {};
    let newArr = [];
    // 屏宽
    const ww = tt.getSystemInfoSync().windowWidth;
    let queue = list.map((ele, i) => {
      // 获取图片高度
      let url = ele + '?x-oss-process=image/info';
      return new Promise((resolve) => {
        tt.request({
          url: url,
          success(res) {
            if (res.statusCode == 200) {
              let nowWidth = (ww - 20) * 0.98;
              // Orientation: 6 （顺时针翻转90度）
              // Orientation : 8 （逆时针翻转90度）
              let picW = '';
              let picH = '';
              if (res.data.Orientation && res.data.Orientation.value == 8 || res.data.Orientation && res.data.Orientation.value == 6) {
                picW = res.data.ImageHeight.value;
                picH = res.data.ImageWidth.value;
              } else {
                picW = res.data.ImageWidth.value;
                picH = res.data.ImageHeight.value;
              }
              obj.height = picH / (picW / nowWidth) / 2 + 5; //计算使用px 避免不同设备展示不同
              obj.height = obj.height.toFixed(2);
            } else {
              obj.height = '90';
            }
            obj.url = ele;
            obj.flag = true;
            // 用于预览图片
            obj.imgIndex = i + start;
            newArr.push(JSON.parse(JSON.stringify(obj)));
            resolve(newArr);
          }
        });
      });
    });
    Promise.all(queue).then((queueItem) => {
      this.setData({
        imgArr: queueItem[0]
      });
      this.getList();
    });
  },
  // 处理页面展示数据
  getList() {
    let {
      listQuery: {
        pageIndex
      },
      column,
      columnsHeights
    } = this.data;
    const columns = [];
    // 上一组的高度数据，用于计算偏移值
    const lastHeights = [...columnsHeights];
    // 获取数据
    const list = this.data.imgArr.sort((a, b) => {
      return a.imgIndex - b.imgIndex;
    });
    // console.log('list', list, lastHeights)
    // 初始化当前屏数据
    for (let i = 0; i < column; i++) {
      columns.push([]);
    }
    // 遍历新数据，分配至各列
    for (let i = 0; i < list.length; i++) {
      // console.log(list[i].height,list[i].imgIndex)
      const position = this.computePosition(columnsHeights);
      columns[position].push(list[i]);
      columnsHeights[position] += Number(list[i].height);
    }
    this.setData({
      [`listData[${pageIndex}]`]: {
        columns,
        columnOffset: this.computeOffset(lastHeights)
      },
      "listQuery.pageIndex": pageIndex + 1,
      currentPage: pageIndex + 1,
      columnsHeights
    });
  },


  /**
   * 获取最小高度列下标
   */
  computePosition(heights) {
    const min = Math.min(...heights);
    return heights.findIndex((item) => item === min);
  },

  /**
   * 计算偏移量
   */
  computeOffset(heights) {
    const max = Math.max(...heights);
    return heights.map((item) => max - item);
  },

  onScrollLower() {
    // && this.data.listData.length > 0切换日期不调用
    if (this.data.listQuery.pageIndex * this.data.listQuery.pageSize < this.data.picGroup.cameraPhotos[this.data.activeDate].photoList.length && this.data.listData.length > 0) {
      this.setImgArr();
    }
  },


  // 吸顶
  scroll(e) {
    let query = tt.createSelectorQuery();
    let height = '';
    query.select('#topImg').boundingClientRect((rect) => {
      //获取到元素
      height = rect.height + 50; //加上活动信息高度
      // console.log(6767, height, e.detail.scrollTop)
      if (e.detail.scrollTop >= height) {
        if (!this.data.ceilingShow) {
          this.setData({
            ceilingShow: true
          });
        }
      } else {
        if (this.data.ceilingShow) {
          this.setData({
            ceilingShow: false
          });
        }
      }
    }).exec();
  },


  // 获取活动信息
  getInfor() {
    let that = this;
    util.ajax({
      func: "v2/child/liveRoomDetail",
      data: {
        "liveId": that.data.liveId
      }
    }, function (res) {
      if (res.code == 0) {
        that.data.activeInfo = res.data;
        tt.setStorageSync('info', res.data);
        that.setData({
          activeInfo: that.data.activeInfo,
          actCity: res.data.city,
          actTime: res.data.deadline
        });
      }
    });
  },
  // 获取图片
  getPicture() {
    let that = this;
    util.ajax({
      func: "v2/child/photoList",
      data: {
        "liveId": that.data.liveId
      }
    }, function (res) {
      if (res.code == 0) {
        let copyRes = res.data.cameraPhotos[0].photoList;
        let copy = [];
        copyRes.map((ele, i) => {
          copy.push(ele);
        });
        that.setData({
          picArr: copy,
          picGroup: res.data
        });
        that.setImgArr();
      }
    });
  },

  // 切换图片
  dataChange(e) {
    // console.log(e.currentTarget.dataset.index)
    let i = e.currentTarget.dataset.index;
    let arr = this.data.picGroup.cameraPhotos[i].photoList;
    let copy = [];
    arr.map((ele, i) => {
      copy.push(ele);
    });
    this.setData({
      // 拍摄日期锚点
      topTimeId: 'tt' + i,
      timeId: 't' + i,
      bottomId: 'p1',
      picArr: copy,
      activeDate: i,
      // 清空页面
      listData: [],
      listQuery: {
        pageIndex: 0,
        pageSize: 12
      },
      currentPage: 0,
      // 列表请求参数
      columnsHeights: [0, 0] // 每列高度
    });
    this.closePro();
    this.setImgArr();
  },


  imgListBinderror(e) {
    let picInfo = e.currentTarget.dataset;
    this.data.listData[picInfo.pageindex].columns[picInfo.columnindex][picInfo.index].url = '/images/noimg.png';
    this.setData({
      listData: this.data.listData
    });
  },

  // 预览图片
  openpreviewImg(e) {
    let that = this;
    let index = e.target.dataset.imgindex;
    let abbreviationPic = [];
    this.data.picArr.forEach((item) => {
      let item1 = {
        url: '',
        originalShow: false
      };
      item1.url = item + '?x-oss-process=image/quality,q_40';
      abbreviationPic.push(item1);
    });
    // console.log(abbreviationPic, index, e, 888, this.data.picArr)
    this.setData({
      defImg: abbreviationPic[index].url, //当前图片
      preList: abbreviationPic, //缩略图列表
      originalArr: this.data.picArr //原图列表
    });
    // 避免再次预览有个切换的过程
    setTimeout(function () {
      that.selectComponent("#previewComponent").showPreview();
    }, 400);

  },
  // 保存选择图片
  checkRadio(e) {
    // console.log(e, 6789678)
    let picInfo = e.currentTarget.dataset;
    let currentItem = this.data.listData[picInfo.pageindex].columns[picInfo.columnindex][picInfo.index];
    if (picInfo.flag == true) {//未选中，修改选中项数组
      if (this.data.checkedGroup.length < 100) {
        this.data.listData[picInfo.pageindex].columns[picInfo.columnindex][picInfo.index].flag = false;
        this.data.checkedGroup.push(currentItem.url);
      } else {
        util.showTips('因照片较大，一次最多保存100张照片～');
      }
    } else {//未选中，修改原数组
      this.data.listData[picInfo.pageindex].columns[picInfo.columnindex][picInfo.index].flag = true;
      this.data.checkedGroup.forEach((el, i) => {
        if (currentItem.url == el) {
          this.data.checkedGroup.splice(i, 1);
        }
      });
    }
    this.setData({
      listData: this.data.listData,
      checkedGroup: this.data.checkedGroup
    });
  },
  // 保存图片的延迟回调
  getTempPath(url) {
    let that = this;
    return new Promise((resolve, reject) => {
      tt.downloadFile({
        url: url,
        success: function (res) {
          that.setData({
            completeNum: that.data.completeNum + 1
          });
          console.log(that.data.completeNum);
          return resolve(res);
        },
        fail: function (err) {
          reject(url + JSON.stringify(err));
        }
      });
    });
  },
  // 保存图片权限判断
  photosAlbum() {
    var that = this;
    tt.getSetting({
      success(res) {
        if (res.authSetting['scope.writePhotosAlbum']) {
          // 已经获得授权，直接存储
          that.save();
        } else
        if (res.authSetting['scope.writePhotosAlbum'] === undefined) {
          // 第一次运行，授权未定义，可以直接保存，系统会一次性询问用户权限
          that.save();
        } else
        {
          // 用户拒绝授权后，打开设置页可以看到授权提示开关
          tt.openSetting({
            success(res) {// 用户授权
              if (res.authSetting['scope.writePhotosAlbum']) {
                that.save();
              } else
              {// 用户拒绝授权
                tt.showToast({
                  title: '权限不足',
                  duration: 3000,
                  icon: 'none'
                });
              }
            },
            fail(res) {
              tt.showToast({
                title: '设置失败',
                duration: 3000,
                icon: 'none'
              });
            }
          });
        }
      },
      fail(res) {
        console.log(res);
        tt.showToast({
          title: '设置失败',
          duration: 3000,
          icon: 'none'
        });
      }
    });
  },
  // 保存图片
  save(event) {
    if (this.data.checkedGroup && this.data.checkedGroup.length > 0) {
      const imageList = [];
      this.setData({
        progressShow: true,
        downloadNum: this.data.checkedGroup.length,
        completeNum: 0,
        downloadCompleted: false
      });
      // 循环数组
      for (let i = 0; i < this.data.checkedGroup.length; i++) {
        imageList.push(this.getTempPath(this.data.checkedGroup[i]));
      }
      console.log(imageList, 777);
      let index = 0;
      while (index < imageList.length) {
        // 将数据分割成多个promise数组
        Promise.all(imageList.slice(index, index += 8)).
        then((res) => {
          // 未取消保存
          if (this.data.progressShow) {
            res.forEach((item) => {
              tt.saveImageToPhotosAlbum({
                filePath: item.tempFilePath,
                success(res) {

                  // console.log(that.data.completeNum)
                }, fail: function (err) {}
              });
            });
          }
        }).
        catch((err) => {
          reject(err);
        });
      }
    } else {
      tt.showToast({
        title: '请选择图片',
        duration: 3000,
        icon: 'none'
      });
    }
  },
  // 关闭下载弹窗和多选，清空选择数据和状态
  closePro() {
    this.data.listData.forEach((item) => {
      item.columns.forEach((cItem) => {
        cItem.forEach((dItem) => {
          dItem.flag = true;
        });
      });
    });

    this.setData({
      progressShow: false,
      selectMore: false,
      listData: this.data.listData,
      checkedGroup: []
    });
  },
  // 下载完成
  downloadComplete() {
    // 最后一次下载
    if (this.data.completeNum == this.data.downloadNum) {
      this.setData({
        downloadCompleted: true
      });
    }
  },
  nps() {
    let that = this,
      npsData = tt.getStorageSync("nps");
    if (npsData.num < util.config.npsNum || util.isObjEmpty(npsData)) {
      util.ajax({
        func: "v2/order/reviews/one"
      }, function (res) {
        if (res.code == 0 && !util.isObjEmpty(res.data)) {
          that.setData({
            npsOptons: res.data,
            npsStatus: true
          });
          npsData.num += 1;
          tt.setStorageSync("nps", npsData);
        }
      });
    }
  },
  // 查看更多
  jumPage() {
    tt.setStorageSync('liveId', this.data.liveId);
    tt.navigateTo({
      url: `/pages/growup/photo/index?liveId=${this.data.liveId}`
    });
  },
  // 批量保存
  selectMore() {
    this.setData({
      selectMore: true,
      checkedGroup: []
    });
  },
  // 去找图
  toFindPhoto() {
    if (util.isObjEmpty(app.globalData.userInfo)) {
      tt.navigateTo({
        url: '/pages/home/account'
      });
      return false;
    }
    tt.navigateTo({
      url: '/pages/growup/findPhoto/index?liveId=' + this.data.liveId
    });
  },

  // 跳转至活动详情
  toDetail() {
    let status = this.data.activeInfo.status;
    if (status == 2) {
      util.showTips('该活动已下架，无法查看。可联系宝大大进行咨询~');
    } else if (status == 0) {
      // 跳转至活动详情页
      tt.navigateTo({
        url: `/pages/product/activity/index?aid=${this.data.activeInfo.aid}`
      });
    } else if (status == 1) {
      //  跳转至详情
      tt.navigateTo({
        url: `/pages/product/activity/index?aid=${this.data.activeInfo.aid}`
      });
    }
  },
  share() {
    this.setData({
      showShare: true
    });
  },
  // 分享
  onShareAppMessage: function () {
    let shareImg = this.data.activeInfo.sharePhoto ? this.data.activeInfo.sharePhoto + '?x-oss-process=image/quality,q_40' : 'https://img.bbztx.com/weixin/applet/share/activity_cover.jpg?x-oss-process=image/quality,q_40';
    return {
      title: '查看活动过程中的精彩图片',
      path: `/pages/growup/activePhoto/index?liveId=${this.data.liveId}`,
      imageUrl: shareImg
    };
  },
  onUnload() {
    this.setData({
      liveId: ""
    });
  },
  // 监听预览图片组件数据
  ComponentListener(e) {
    // 滑动到指定张加载后面的
    if (e.detail.type == 'slide') {
      // 未加载过的页数
      if (e.detail.currentPage > this.data.listQuery.pageIndex) {
        this.onScrollLower();
      }
    } else {//关闭预览 跳到指定照片
      let bottomId = 'p' + (e.detail.imgindex - 2); //定位到前2张，保证要定位的照片不被遮挡
      this.setData({
        bottomId,
        currentPage: e.detail.currentPage
      });
    }
    // console.log(e, 78787)
  }
});