const util = require("../../../utils/util.js");
var app = getApp();

Page({

  /**
   * 页面的初始数据
   */
  data: {
    liveId: '',
    timesList: [{}, {}, {}, {}, {}, {}, {}], //可上传次数列表
    imgList: [], //单人正面照列表
    imgListNum: 3, //单人正面照可上传数
    faceResult: [], //人脸结果
    headsPhotoIndex: 0, //正面照片选中
    faceResultIndex: 0, //脸部照片选中
    photographer: false, //只看摄影师照片
    uploadConfShow: false, //上传确认弹窗
    newUploadReason: '', // 需重新上传原因
    agree: false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.setData({
      liveId: options.liveId
    });
    this.getPicture();
    return;
  },


  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },
  // 获取最新结果
  getLatestResults() {




    // this.getPicture('latestResults')
    // if (status == 'latestResults') {
    //   util.showTips('已获取最新结果');
    // }
  }, checkboxChange() {this.setData({ photographer: !this.data.photographer });
    this.getIdentifye();
  },

  // 获取已上传图片
  getPicture(status) {
    let that = this;
    util.ajax({
      func: "aliFace/getUserImageList",
      data: {
        "liveId": that.data.liveId
      }
    }, function (res) {
      if (res.code == 0) {
        // 上传后获取定位到新上传的
        if (status == 'newPic' && res.data.list.length > 0) {
          that.setData({
            headsPhotoIndex: res.data.list.length - 1,
            faceResultIndex: 0
          });
        }
        that.setData({
          imgListNum: res.data.total,
          imgList: res.data.list,
          faceResult: res.data.list ? res.data.list[that.data.headsPhotoIndex].headList : [] //人脸结果
        });
        // 有上传调用后续
        if (res.data.list && res.data.list.length > 0) {
          that.getIdentifye();
        }
      }
    });
  },
  // 获取识别结果
  getIdentifye() {
    let that = this;
    util.ajax({
      func: "aliFace/getUserSearchList",
      data: {
        "queryPhotoTeam": that.data.photographer ? 1 : '', // 是否获取摄影师队伍的照片：1-只获取摄影师队伍，0-不获取摄影师队伍，为空-获取全部 ,
        "userImageId": that.data.faceResult[that.data.faceResultIndex] ? that.data.faceResult[that.data.faceResultIndex].id : ''
      },
      method: "POST"
    }, function (res) {
      if (res.code == 0) {
        let arr = [];
        // 都有
        if (res.data.cameraPhotos && res.data.cameraPhotos.length > 0 && res.data.teamPhotos && res.data.teamPhotos.length > 0) {
          arr = res.data.cameraPhotos;
          arr.push(...res.data.teamPhotos);
          var map = {},dest = [];
          for (var i = 0; i < arr.length; i++) {
            var ai = arr[i];
            if (!map[ai.date]) {
              dest.push({ date: ai.date, photoList: ai.photoList });
              map[ai.date] = ai;
            } else {
              for (var j = 0; j < dest.length; j++) {
                var dj = dest[j];
                if (dj.date == ai.date) {
                  dj.photoList.push(...ai.photoList);
                  break;
                }
              }
            }
          };
          arr = dest;
        } else if (res.data.cameraPhotos && res.data.cameraPhotos.length > 0) {
          arr = res.data.cameraPhotos;
        } else if (res.data.teamPhotos && res.data.teamPhotos.length > 0) {
          arr = res.data.teamPhotos;
        }
        var reg = /(\d{4})\-(\d{2})\-(\d{2})/;
        if (arr && arr.length > 0) {
          arr.forEach((item) => {
            item.date = item.date.replace(reg, "$2月$3日");
          });
        }
        that.setData({
          photoData: arr
        });
      }
    });
  },
  // 条款
  agreeChange(e) {
    this.setData({
      agree: !this.data.agree
    });
  },
  openDoc() {
    let url = '/pages/public/swiper/web?url=' + 'https://h5.bbztx.com/miniProgramFaceRecognition' + '&title=' + encodeURIComponent('人脸识别使用条款');
    tt.navigateTo({
      url: url
    });
  },
  addPic() {
    // 已同意不弹
    if (this.data.agree) {
      this.selectPic();
    } else {
      this.setData({
        uploadConfShow: true
      });
    }
  },
  showSelectPic() {
    this.setData({
      uploadConfShow: false,
      agree: false
    });
  },
  // 清空重新上传原因，隐藏弹窗
  cleanNewUploadReason() {
    this.setData({
      newUploadReason: ''
    });
  },
  // 选择图片
  selectPic() {
    if (!this.data.agree) {
      util.showTips('请认真阅读相关协议条款，并认可同意。');
      return false;
    }
    let that = this;
    tt.chooseMedia({
      count: 1,
      mediaType: ['image'],
      sizeType: ['compressed', 'compressed'], //可以指定是原图还是压缩图
      sourceType: ['album', 'camera'], //从相册选择
      success: (imgRes) => {
        // 图片不能大于5M
        if (imgRes.tempFiles[0].size > 1024 * 1024 * 5) {
          util.showTips('上传图片不能大于5M');
          return false;
        }
        let extStart = imgRes.tempFiles[0].tempFilePath.lastIndexOf(".");
        let imageName = imgRes.tempFiles[0].tempFilePath;
        let ext = imageName.substring(extStart, imageName.length).toUpperCase();
        //判断图片格式
        if (ext !== '.PNG' && ext !== '.JPG' && ext !== '.JPEG') {
          util.showTips('图片格式不正确，请重新选择');
          return false;
        }
        let avatarUrl = imgRes.tempFiles[0].tempFilePath;
        that.setData({
          uploadConfShow: false,
          newUploadReason: ''
        });
        tt.showLoading({
          title: '人脸识别中…',
          mask: true
        });
        util.uploadFile("oss/policy", avatarUrl, {
          type: 'face'
        }, true).then((res) => {
          if (res.code == 0) {
            that.uploadHeads(res.url);
          }
        });
      }
    });
  },
  // 上传孩纸单人正面照
  uploadHeads(url) {
    let that = this;
    util.ajax({
      func: "aliFace/addUserImage",
      data: {
        "liveId": that.data.liveId,
        "imageUrl": url
      },
      method: "POST"
    }, function (res) {
      if (res.code == 0) {
        // 添加定时刷新
        setTimeout(function () {
          that.setTimeRefresh();
        }, 2000);
      } else {
        tt.hideLoading();
        that.setData({
          newUploadReason: res.reason
        });
      }
    });
  },
  // 定时刷新
  setTimeRefresh() {
    let that = this;
    util.ajax({
      func: "aliFace/getUserImageAddResult",
      method: "GET"
    }, function (res) {
      if (res.code == 0) {
        if (res.data == 'running') {
          // 获取中再定时刷新
          setTimeout(function () {
            that.setTimeRefresh();
          }, 2000);
        } else if (res.data == 'success') {
          //  获取成功走后续
          that.getPicture('newPic');
          util.showTips('人脸识别成功');
        } else {//data为空
          that.getPicture('newPic');
          util.showTips('人脸识别成功');
        }
      } else {
        // 获取失败提示语
        tt.hideLoading();
        that.setData({
          newUploadReason: res.reason
        });
      }
    });
  },
  // 正面照选择
  headsCheck(e) {
    this.setData({
      headsPhotoIndex: e.currentTarget.dataset.index,
      faceResult: this.data.imgList[e.currentTarget.dataset.index].headList,
      faceResultIndex: 0 //人脸结果回到第一个
    });
    // 获取新的识别结果
    this.getIdentifye();
  },
  // 脸部照选择
  headCheck(e) {
    this.setData({
      faceResultIndex: e.currentTarget.dataset.index,
      photographer: false
    });
    // 获取新的识别结果
    this.getIdentifye();
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
});