const util = require('../../../utils/util.js');
const app = getApp();
Page({
  data: {
    img: util.config.imgPath,
    queryData: {
      otype: 0,
      pageIndex: 1,
      pageSize: 20
    },
    stat: {},
    list: [],
    loadMore: true,
    modalInfo: {
      show: false,
      aid: '',
      orderid: ''
    },
    IMShow: false,
    // 点击待参加按钮状态 1-未排期 2-未添加出行人
    pendingStatus: 1,
    orderId: '',
    // 客服抖音号 todo:
    imId: 'Haimli',
    lineType: '1',
    imType: 'order',
    // ——inviteFbtn 是否显示邀请海报按钮
  },
  imCallback(e) {
    console.log("跳转IM客服成功", e.detail);
    this.setData({
      IMShow: false
    })
  },
  cleanIMShow() {
    this.setData({
      IMShow: false
    })
  },
  showIm(e) {
    console.log(e)
    this.setData({
      IMShow: true,
      pendingStatus: e.target.dataset.pendingstatus
    })
  },
  onLoad(options) {
    console.log(options);
    this.data.queryData.otype = options.otype || 0;
    this.setData({
      queryData: this.data.queryData
    });
  },
  onShow() {
    // 重置
    this.setData({
      'queryData.pageIndex': 1
    });
    this.stat();
    this.getList(false);
  },
  setTabbar(e) {
    let index = e.currentTarget.dataset.index;
    this.data.queryData.otype = index;
    this.data.queryData.pageIndex = 1;
    this.setData({
      queryData: this.data.queryData,
      list: []
    });
    this.getList(true);
  },
  stat() {
    let that = this;
    util.ajax({
      func: 'v2/user/stat',
      data: {
        tiktokOrder: 1
      },
      load: false
    }, (data) => {
      if (data.code == 0) {
        that.setData({
          stat: data.data
        });
      }
    });
  },
  getList(load) {
    let that = this;
    that.data.queryData.tiktokOrder = 1
    util.ajax({
      func: "v2/order/list",
      data: that.data.queryData,
      load: load,
      title: '加载中…'
    }, function (res) {
      if (res.code == 0) {
        let newData = res.data.list || [];
        if (newData.length > 0) {
          newData.forEach((el) => {
            // 尾款可支付时间
            if (el.saleTime && el.saleTime > 0) {
              el.saleTime = util.formatDate(util.formatUnixtimestamp(el.saleTime), 'MM月dd日 hh:mm', false);
            }
            // 支付尾款截肢时间
            if (el.presellPaymentDeadline && el.presellPaymentDeadline > 0) {
              el.failureTime = util.formatDate(util.formatUnixtimestamp(el.presellPaymentDeadline), 'MM月dd日 hh:mm', false);
            }
            if (el.deadline && el.deadline > 0) {
              el.startTime = util.formatDate(util.formatUnixtimestamp(el.deadline), 'yyyy-MM-dd', false);
            }
            el.timeContrast = util.timeContrast(el.stopBuy);
          });
        }
        let loadMore = true,
          oldData = !load ? newData : [...that.data.list, ...newData];
        if (newData.length < that.data.queryData.pageSize && oldData.length > that.data.queryData.pageSize) loadMore = false;
        that.setData({
          list: oldData,
          loadMore
        });
      } else
        util.showTips(res.reason);
    });
  },
  cancelOrder(e) {
    let that = this,
      orderid = e.currentTarget.dataset.orderid;
    util.ajax({
      func: "order/cancel",
      data: {
        orderid
      }
    }, function (res) {
      if (res.code == 0) {
        that.data.queryData.pageIndex = 1;
        that.setData({
          queryData: that.data.queryData
        });
        that.stat();
        that.getList(false);
      } else {
        util.showTips(res.reason);
      }
    });
  },
  cancelRefund(e) {
    let that = this,
      orderid = e.currentTarget.dataset.orderid;
    util.ajax({
      func: "order/cancel_refund",
      data: {
        orderid,
        password: ''
      }
    }, function (res) {
      if (res.code == 0) {
        that.data.queryData.pageIndex = 1;
        that.setData({
          queryData: that.data.queryData
        });
        that.getList(false);
      } else {
        util.showTips(res.reason);
      }
    });
  },
  comment(e) {
    let orderid = e.currentTarget.dataset.orderid;
    tt.navigateTo({
      url: '/pages/order/comment/comment?orderid=' + orderid + '&otype=' + this.data.queryData.otype
    });
  },
  // 跳转至表单详情页（支付尾款）
  jumpBalancePayment(e) {
    console.log(e);
    let data = e.currentTarget.dataset;
    tt.navigateTo({
      url: '/pages/product/balancePayment/balancePayment?aid=' + data.aid + '&otype=' + data.otype + '&orderid=' + data.orderid + '&presellstatus=' + data.presellstatus + '&campsex=' + data.campsex + '&military=' + data.military
    });
  },
  // 立即支付（支付尾款） --待付款状态
  pay(e) {
    // 判断当前API是否正在调用
    if (this.data.APILoading) {
      return
    }
    this.setData({
      APILoading: true
    })
    let that = this;
    console.log(e, '付款');
    util.TTPay(e.target.dataset.outtradeno)
      .then(res => {
        // 重置调用状态
        that.setData({
          APILoading: false
        })
        that.stat();
        that.getList(false);
      })
      .catch(err => {
        // 重置调用状态
        that.setData({
          APILoading: false
        })
        if (err.errNo != 4) {
          util.showTips(err.errMsg);
        }
      })
  },
  errorImg(e) {
    this.data.list[e.currentTarget.dataset.index].logo = "/images/noimg.png";
    this.setData({
      list: this.data.list
    });
  },
  onPullDownRefresh() {
    var self = this;
    tt.showNavigationBarLoading();
    setTimeout(function () {
      self.data.queryData.pageIndex = 1;
      self.setData({
        queryData: self.data.queryData
      });
      self.getList(false);
      tt.hideNavigationBarLoading();
      tt.stopPullDownRefresh();
    }, 1000);
  },
  onReachBottom() {
    var self = this;
    if (self.data.loadMore == false) return false;

    setTimeout(function () {
      self.data.queryData.pageIndex = self.data.queryData.pageIndex + 1;
      self.setData({
        queryData: self.data.queryData
      });
      self.getList(true);
    }, 1000);
  },
  // 邀请拼团
  inviteGroup(ev) {
    console.log(ev);
    let data = ev.currentTarget.dataset.info;
    let obj = {
      show: true,
      aid: data.aid,
      orderid: data.orderid,
      sid: data.sid,
      pid: data.pid,
      logo: data.logo,
      title: data.atitle,
      status: data.status,
      invite: app.globalData.userInfo.code,
      from: 'button',
      sharer: app.globalData.userInfo.nickname,
      groupbook: data.groupbook,
      invitefbtn: ev.currentTarget.dataset.invitefbtn == '0' ? true : false
    };
    if (!util.isEmpty(data.groupid) && data.groupid != 'null' && data.groupid != 'undefined' && data.status != 15) {
      obj.groupid = data.groupid;
    }
    this.setData({
      modalInfo: obj
    });
  },
  onShareAppMessage() {
    console.log(this.data.modalInfo);
    let title = '个人订单信息',
      url = '/pages/index/order',
      logo = "../images/share.png";
    if (this.data.modalInfo.from === 'button') {
      let data = this.data.modalInfo,
        str = [];
      if (!util.isEmpty(data.sid) && !util.isEmpty(data.pid) && util.isEmpty(data.groupid)) {
        title = data.sharer + '已报名并邀请你一起参与' + data.title;
      } else {
        title = "约吗？快来和我家孩子一起拼团挑战" + data.title;
      }
      str.push('aid=' + data.aid);
      str.push('orderid=' + data.orderid);
      str.push('invite=' + data.invite);
      str.push('sharesid=' + data.sid);
      str.push('sharepid=' + data.pid);
      str.push('sharer=' + data.sharer);
      if (!util.isEmpty(data.groupid) && data.groupid != 'null' && data.groupid != 'undefined' && data.groupbook == 1) {
        str.push('groupid=' + data.groupid);
      }
      url = "/pages/product/activity/index?" + str.join('&');
      logo = data.logo.indexOf("noimg.png") == -1 ? data.logo + '@!logo' : logo;
    }
    console.log(url);
    return {
      title: title,
      path: url,
      imageUrl: logo
    };
  }
});