const util = require("../../../utils/util.js");
const app = getApp();
Page({
  data: {
    orderid: "",
    jump: true,
    alone: 0, //0单独报名,1拼团
    info: {},
    imgUrl: util.config.imgPath,
    presellStatus: '',
    presellOpen: '',
    btype: 0,
    iconView: false,
    link: '',
    tradeChannelWeixin: '',
    // 客服抖音号 todo:
    imId: 'Haimli',
    lineType: '1',
    imType: 'order',
  },
  imCallback(e) {
    console.log("跳转IM客服成功", e.detail);
    this.setData({
      IMShow: false
    })
  },
  onLoad(options) {
    console.log('success', options);
    if (util.isEmpty(options.orderid)) {
      util.showTips('缺少订单号。');
      return false;
    }
    if (!util.isObjEmpty(options)) {
      this.setData({
        orderid: options.orderid,
      });
      this.getInfo();
    }
  },

  jumpToHome(e) {
    let url = e.currentTarget.dataset.url;
    this.setData({
      jump: false
    });
    tt.reLaunch({
      url: url
    });
  },

  getInfo: function () {
    var that = this

    util.ajax({
      func: "v2/order/simle/detail",
      data: {
        "outTradeNo": that.data.orderid,
      }
    }, function (res) {
      if (res.code == 0) {
        that.setData({
          info: res.data
        });
        // 定义跳转订单详情页链接
        let link = '/pages/order/detail/index?orderid=' + that.data.info.orderid;
        link = link + '&otype=0' + '&presellStatus=0'
        that.setData({
          link
        });
      } else {
        util.showTips(res.reason);
      }
    });
  },
  onShareAppMessage(res) {
    let info = this.data.info,
      data = [],
      title = "";
    data.push('aid=' + info.aid);
    data.push('invite=' + app.globalData.userInfo.code);
    data.push('sharesid=' + info.sid);
    data.push('sharepid=' + info.pid);
    data.push('sharer=' + app.globalData.userInfo.nickname);
    if (!util.isEmpty(info.groupinfo.groupid) && info.groupinfo.groupid != 'null' && info.groupinfo.groupid != 'undefined' && info.groupinfo.groupbook == 1 && info.subOrders[0].status != 15) {
      data.push('groupid=' + info.groupinfo.groupid);
    }
    if (!util.isEmpty(info.sid) && !util.isEmpty(info.pid) && util.isEmpty(info.groupinfo.groupid)) {
      title = app.globalData.userInfo.nickname + '已报名并邀请你一起参与' + info.title;
    } else {
      title = (info.groupinfo ? '约吗？快来和我家孩子一起拼团挑战' : '') + info.title;
    }
    return {
      title: title,
      path: info.groupinfo ? '/pages/product/activity/index?' + data.join('&') : '/pages/home/index',
      imageUrl: info.groupinfo ? '' : '../images/share.png'
    };
  }
});