const util = require('../../utils/util.js');
const app = getApp();
Page({
  data: {
    img: util.config.imgPath,
    pickers: [],
    pickerIndex: 0,
    tabsIndex: 0,
    queryData: {
      pageIndex: 1,
      pageSize: 10,
      cities: app.globalData.city.city
    },
    info: {},
    list: [],
    total: 0,
    loadMore: true
  },
  onLoad: function () {
    this.getCity();
    this.userInfo();
  },
  getCity() {
    let that = this;
    util.ajax({
      func: "city_list",
      load: false
    }, function (res) {
      if (res.code == 0 && res.data) {
        // 去除永康城市
        res.data.city.forEach((item, index) => {
          if (item == '永康') {
            res.data.city.splice(index, 1);
          }
        });
        that.setData({ pickers: res.data.city, pickerIndex: res.data.city.indexOf(that.data.queryData.cities) });
      }
    });
  },
  bindCityChange(e) {
    this.data.queryData.pageIndex = 1;
    this.data.queryData.cities = this.data.pickers[e.detail.value];
    this.setData({ pickerIndex: e.detail.value, queryData: this.data.queryData });
    this.getList(false);
  },
  userInfo() {
    let that = this;
    util.ajax({
      func: "v2/user/info",
      load: false
    }, function (res) {
      if (res.code == 0 && res.data) {
        that.setData({ info: res.data });
        that.getList(false);
      }
    });
  },
  setTabbar(e) {
    let index = e.currentTarget.dataset.index;
    this.data.queryData.pageIndex = 1;
    this.setData({ tabsIndex: index, queryData: this.data.queryData, list: [] });
    this.getList(true);
  },
  stat() {
    let that = this;
    util.ajax({
      func: 'v2/user/stat',
      data:{tiktokOrder:1},
      load: false
    }, (data) => {
      if (data.code == 0) {
        that.setData({ stat: data.data });
      }
    });
  },
  getList(load) {
    let that = this;
    util.ajax({
      func: `v2/${that.data.info.roleType}/articles`,
      data: { ...that.data.queryData, days: that.data.tabsIndex == 4 ? 5 : that.data.tabsIndex },
      load: load
    }, function (res) {
      if (res.code == 0) {
        let loadMore = true,newData = res.data.list || [],oldData = !load ? newData : [...that.data.list, ...newData];
        if (newData.length < that.data.queryData.pageSize && oldData.length > that.data.queryData.pageSize) loadMore = false;
        that.setData({ list: oldData, loadMore, total: res.data.total });
      } else
      util.showTips(res.reason);
    });
  },
  errorImg(e) {
    this.data.list[e.currentTarget.dataset.index].logo = "/images/noimg.png";
    this.setData({ list: this.data.list });
  },
  onPullDownRefresh() {
    var self = this;
    tt.showNavigationBarLoading();
    setTimeout(function () {
      self.data.queryData.pageIndex = 1;
      self.setData({ queryData: self.data.queryData });
      self.getList(false);
      tt.hideNavigationBarLoading();
      tt.stopPullDownRefresh();
    }, 1000);
  },
  onReachBottom() {
    var self = this;
    if (self.data.loadMore == false || self.data.total <= self.data.queryData.pageSize) return false;

    setTimeout(function () {
      self.data.queryData.pageIndex = self.data.queryData.pageIndex + 1;
      self.setData({ queryData: self.data.queryData });
      self.getList(true);
    }, 1000);
  }
});